/* ==========================================================================
**
**                   EmbossedGadgetClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef EMBOSSEDGADGETCLASS_H
#define EMBOSSEDGADGETCLASS_H


#include "EmbossedGadget.h"
#include "InteractorClass.h"
#include "parms.h"

void EmbossedGadget_Init __PARMS(( EmbossedGadget *gadget,
                          PIXELS          LeftEdge,
                          PIXELS          TopEdge,
                          PIXELS          Width,
                          PIXELS          Height,
                          USHORT          Flags,
                          USHORT          Activation,
                          USHORT          GadgetType,
                          pcg_3DPens      Pens,
                          char           *Label ));


struct InteractorClass *EmbossedGadgetClass __PARMS(( void ));

void EmbossedGadgetClass_Init __PARMS(( struct InteractorClass *class ));

EmbossedGadget *EmbossedGadget_New __PARMS(( EmbossedGadget *self ));

void EmbossedGadget_CleanUp __PARMS(( EmbossedGadget *self ));

tPoint EmbossedGadget_SetLocation __PARMS((  EmbossedGadget *self,
                                    PIXELS          LeftEdge,
                                    PIXELS          TopEdge ));

tPoint EmbossedGadget_AskSize __PARMS(( EmbossedGadget *self,
                               PIXELS          Width,
                               PIXELS          Height ));

tPoint EmbossedGadget_SetSize __PARMS(( EmbossedGadget *self,
                               PIXELS          Width,
                               PIXELS          Height ));

Gadget *EmbossedGadget_FirstGadget __PARMS(( EmbossedGadget *self ));


USHORT EmbossedGadget_nGadgets __PARMS(( EmbossedGadget *self ));


ULONG EmbossedGadget_IDCMPFlags __PARMS(( EmbossedGadget *self ));


USHORT EmbossedGadget_ClaimEvent __PARMS(( EmbossedGadget *self,
                                  IntuiMessage   *event ));


USHORT EmbossedGadget_Respond __PARMS(( EmbossedGadget   *self,
                               IntuiMessage     *Event ));


void EmbossedGadget_Refresh __PARMS(( EmbossedGadget *self ));
/* Performs a 'RefreshGList()' on the gadget(s) of self. */


void EmbossedGadget_Render __PARMS(( EmbossedGadget *self,
                            RastPort       *RPort ));
/* Attempts to draw the Gadget Border/Image, and GadgetText to RPort. */


BOOL EmbossedGadget_EnableIactor __PARMS(( EmbossedGadget *self,
                            BOOL            enable ));


BOOL EmbossedGadget_isEnabled __PARMS(( Interactor *self )); /* , FIXED? -- EDB */
                             /*  BOOL       enable )); */ /* BROKEN -- EDB */

char *EmbossedGadget_Title __PARMS(( EmbossedGadget *self ));

BOOL EmbossedGadget_SetTitle __PARMS(( EmbossedGadget *self,
                              char           *title ));
/* Added Default Font Methods -- EDB */
TextAttr *EmbossedGadget_DefaultFont __PARMS(( EmbossedGadget *self ));

BOOL EmbossedGadget_SetDefaultFont __PARMS(( EmbossedGadget *self, TextAttr *default_font ));
   /*
   ** returns FALSE if default_font points to NULL.
   ** returns FALSE if object cannot open specified font.
   */

#endif
