/* ==========================================================================
**
**                   GraphicObjectClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef GRAPHICOBJECTCLASS_H
#define GRAPHICOBJECTCLASS_H

#include "PObjectClass.h"
#include "GraphicObject.h"
#include "parms.h"


struct GraphicObjectClass
{
	OBJECTMETHODS

   Point (*Location) __PARMS(( GraphicObject *self ));

   Point (*SetLocation)
             __PARMS(( GraphicObject *self,
              PIXELS       LeftEdge,
              PIXELS       TopEdge ));

   Point (*Size) __PARMS(( GraphicObject* self ));

   Point (*AskSize)
             __PARMS(( GraphicObject *self,
              PIXELS       Width,
              PIXELS       Height ));

   Point (*SetSize)
             __PARMS(( GraphicObject *self,
              PIXELS       Width,
              PIXELS       Height ));

   UWORD  (*SizeFlags)
             __PARMS(( GraphicObject *self ));

   void (*Render)
             __PARMS(( GraphicObject *self,
              RastPort     *RPort ));

   BOOL (*SetTitle)
             __PARMS(( GraphicObject *self,
              char          *title ));

   char *(*Title) __PARMS(( GraphicObject *self ));

/* additions for font information */
   TextAttr *(*DefaultFont) __PARMS(( GraphicObject *self ));
   BOOL (*SetDefaultFont) __PARMS(( GraphicObject *self, TextAttr *default_font ));

   AlignInfo *(*TextAlignment)
             __PARMS(( GraphicObject *self ));

   BOOL (*SetTextAlignment)
             __PARMS(( GraphicObject *self,
              UBYTE        Flags,
              BYTE          Xpad,
              BYTE          Ypad ));

   struct BuilderMethods *BuilderMethods;

};


struct GraphicObjectClass *GraphicObjectClass __PARMS(( void ));

void GraphicObjectClass_Init __PARMS(( struct GraphicObjectClass *class ));

UWORD GraphicObject_SizeFlagsNone __PARMS(( GraphicObject *self ));
UWORD GraphicObject_SizeFlagsX __PARMS(( GraphicObject *self ));
UWORD GraphicObject_SizeFlagsY __PARMS(( GraphicObject *self ));
UWORD GraphicObject_SizeFlagsAll __PARMS(( GraphicObject *self ));




AlignInfo *TextAlignment __PARMS(( GraphicObject* self ));

BOOL SetTextAlignment __PARMS(( GraphicObject* self,
			 UBYTE	 Flags,
			 BYTE	 Xpad,
			 BYTE	 Ypad ));


#endif
