/* ==========================================================================
**
**                   InteractorClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef INTERACTORCLASS_H
#define INTERACTORCLASS_H

#include <exec/types.h>
#include "Interactor.h"
#include "GraphicObjectClass.h"
#include "pcgWindow.h"
#include "parms.h"

struct InteractorClass
{
   const PClass *isa;
   char  *ClassName;

   void   (*CleanUp)
             __PARMS(( PObject *self ));
   tPoint (*Location)
             __PARMS(( GraphicObject *self ));
   tPoint (*SetLocation)
             __PARMS(( GraphicObject *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge ));
   tPoint (*Size)
             __PARMS((  GraphicObject *self ));
   tPoint (*AskSize)
             __PARMS(( GraphicObject *self,
              PIXELS            Width,
              PIXELS            Height ));
   tPoint (*SetSize)
             __PARMS(( GraphicObject *self,
              PIXELS      Width,
              PIXELS      Height ));
   UWORD  (*SizeFlags)
             __PARMS(( GraphicObject *self ));

   void (*Render)
             __PARMS(( GraphicObject *self,
              RastPort  *RPort ));

   BOOL (*SetTitle)
             __PARMS(( GraphicObject *self,
              char      *title ));

   char *(*Title)
             __PARMS(( GraphicObject *self ));

/* additions for font information */
   TextAttr *(*DefaultFont) __PARMS(( GraphicObject *self ));
   BOOL (*SetDefaultFont) __PARMS(( GraphicObject *self, TextAttr *default_font ));

   AlignInfo *(*TextAlignment) __PARMS(( GraphicObject *self ));

   BOOL (*SetTextAlignment)
             __PARMS(( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad ));

   PClass *BuilderMethods;

/*--- New Methods ----------------------------*/

   struct pcgWindow *(*InteractorWindow)
             __PARMS(( Interactor *self ));

   void (*SetInteractorWindow)
             __PARMS(( Interactor *self,
              struct pcgWindow *window ));

   Gadget *(*FirstGadget)
             __PARMS(( Interactor *self ));

   USHORT (*nGadgets)
             __PARMS(( Interactor *self ));

   ULONG (*IDCMPFlags)
             __PARMS(( Interactor *self ));

   USHORT (*ClaimEvent)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   USHORT (*Respond)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   void (*Refresh)
             __PARMS(( Interactor *self ));

   BOOL (*EnableIactor)
             __PARMS(( Interactor *self,
              BOOL       enable ));

   BOOL (*isEnabled)
             __PARMS(( Interactor *self  ));

   BOOL (*Activate)
             __PARMS(( Interactor *self,
              BOOL       activate ));

   BOOL (*isActive)
             __PARMS(( Interactor *self ));

};

struct InteractorClass *InteractorClass __PARMS(( void ));

void InteractorClass_Init __PARMS(( struct InteractorClass *class ));

#endif