/* ==========================================================================
**
**                   PositionerClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef POSITIONERCLASS_H
#define POSITIONERCLASS_H

#include "Positioner.h"
#include "ValuatorClass.h"


struct PositionerClass
{
   const PClass *isa;
   char  *ClassName;

   void   (*CleanUp)
             __PARMS(( PObject *self ));
   Point (*Location)
             __PARMS(( GraphicObject *self ));
   Point (*SetLocation)
             __PARMS(( GraphicObject *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge ));
   Point (*Size)
             __PARMS(( GraphicObject *self ));
   Point (*AskSize)
             __PARMS(( GraphicObject *self,
              PIXELS            Width,
              PIXELS            Height ));
   Point (*SetSize)
             __PARMS(( GraphicObject *self,
              PIXELS      Width,
              PIXELS      Height ));
   UWORD  (*SizeFlags)
             __PARMS(( GraphicObject *self ));

   void (*Render)
             __PARMS(( GraphicObject *self,
              RastPort  *RPort ));

   BOOL (*SetTitle)
             __PARMS(( GraphicObject *self,
              char      *title ));

   char *(*Title)
             __PARMS(( GraphicObject *self ));

/* additions for font information */
   TextAttr *(*DefaultFont) __PARMS(( GraphicObject *self ));
   BOOL (*SetDefaultFont) __PARMS(( GraphicObject *self, TextAttr *default_font ));

   AlignInfo *(*TextAlignment) __PARMS(( GraphicObject *self ));

   BOOL (*SetTextAlignment)
             __PARMS(( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad ));

   PClass *BuilderMethods;

   struct pcgWindow *(*InteractorWindow)
             __PARMS(( Interactor *self ));

   void (*SetInteractorWindow)
             __PARMS(( Interactor *self,
              struct pcgWindow *window ));

   Gadget *(*FirstGadget)
             __PARMS(( Interactor *self ));

   USHORT (*nGadgets)
             __PARMS(( Interactor *self ));

   ULONG (*IDCMPFlags)
             __PARMS(( Interactor *self ));

   USHORT (*ClaimEvent)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   USHORT (*Respond)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   void (*Refresh)
             __PARMS(( Interactor *self ));

   BOOL (*EnableIactor)
             __PARMS(( Interactor *self,
              BOOL       enable ));

   BOOL (*isEnabled)
             __PARMS(( Interactor *self  ));

   BOOL (*Activate)
             __PARMS(( Interactor *self,
              BOOL       activate ));

   BOOL (*isActive)
             __PARMS(( Interactor *self ));

   LONG (*Value)
             __PARMS(( Valuator *self ));

   LONG (*SetValue)
             __PARMS(( Valuator *self,
              LONG      selection ));

/*--- New Methods ----------------------------*/

   USHORT (*KnobSize)
             __PARMS(( Positioner *self ));

   USHORT (*SetKnobSize)
             __PARMS(( Positioner *self,
              USHORT      knobsize ));

};


struct PositionerClass *PositionerClass __PARMS(( void ));

void PositionerClass_Init __PARMS(( struct PositionerClass *class ));


#endif
