/* ==========================================================================
**
**                         StringListerClass.h
**
** 1991 WILLISoft
**
** ==========================================================================
*/

#ifndef STRINGLISTERCLASS_H
#define STRINGLISTERCLASS_H

#include "StringLister.h"
#include "InteractorClass.h"


struct StringListerClass
{
   const PClass *isa;
   char  *ClassName;

   void   (*CleanUp)
             __PARMS(( PObject *self ));
   Point (*Location)
             __PARMS(( GraphicObject *self ));
   Point (*SetLocation)
             __PARMS(( GraphicObject *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge ));
   Point (*Size)
             __PARMS(( GraphicObject *self ));
   Point (*AskSize)
             __PARMS(( GraphicObject *self,
              PIXELS            Width,
              PIXELS            Height ));
   Point (*SetSize)
             __PARMS(( GraphicObject *self,
              PIXELS      Width,
              PIXELS      Height ));
   UWORD  (*SizeFlags)
             __PARMS(( GraphicObject *self ));

   void (*Render)
             __PARMS(( GraphicObject *self,
              RastPort  *RPort ));

   BOOL (*SetTitle)
             __PARMS(( GraphicObject *self,
              char      *title ));

   char *(*Title)
             __PARMS(( GraphicObject *self ));

/* additions for font information */
   TextAttr *(*DefaultFont) __PARMS(( GraphicObject *self ));

   BOOL (*SetDefaultFont) __PARMS(( GraphicObject *self, TextAttr *default_font ));

   AlignInfo *(*TextAlignment) __PARMS(( GraphicObject *self ));

   BOOL (*SetTextAlignment)
             __PARMS(( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad ));

   PClass *BuilderMethods;

   struct pcgWindow *(*InteractorWindow)
             __PARMS(( Interactor *self ));

   void (*SetInteractorWindow)
             __PARMS(( Interactor *self,
              struct pcgWindow *window ));

   Gadget *(*FirstGadget)
             __PARMS(( Interactor *self ));

   USHORT (*nGadgets)
             __PARMS(( Interactor *self ));

   ULONG (*IDCMPFlags)
             __PARMS(( Interactor *self ));

   USHORT (*ClaimEvent)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   USHORT (*Respond)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   void (*Refresh)
             __PARMS(( Interactor *self ));

   BOOL (*EnableIactor)
             __PARMS(( Interactor *self,
              BOOL       enable ));

   BOOL (*isEnabled)
             __PARMS(( Interactor *self  ));

   BOOL (*Activate)
             __PARMS(( Interactor *self,
              BOOL       activate ));

   BOOL (*isActive)
             __PARMS(( Interactor *self ));

/*----- New methods ---------------*/

   BOOL (*AddString)
             __PARMS(( StringLister *self, char *string, UBYTE qualifier ));

   BOOL (*DeleteString)
             __PARMS(( StringLister *self, USHORT i ));

   BOOL (*DeleteAllStrings)
             __PARMS(( StringLister *self ));

   StringList *(*StringList_of)
             __PARMS(( StringLister *self ));

   void (*SelectString)
             __PARMS(( StringLister *self,
              USHORT         i,
              BOOL           select ));
};


void StringLister_Init __PARMS(( StringLister *self ));

struct StringListerClass *StringListerClass __PARMS(( void ));

void StringListerClass_Init __PARMS(( struct StringListerClass *class ));

#endif
