#ifndef PCGWINDOWCLASS_H
#define PCGWINDOWCLASS_H

#include "pcgWindow.h"
#include "InteractorClass.h"

struct pcgWindowClass
{
   PClass *isa;
   char  *ClassName;

   void   (*CleanUp)
             __PARMS(( PObject *self ));
   tPoint (*Location)
             __PARMS(( GraphicObject *self ));
   tPoint (*SetLocation)
             __PARMS(( GraphicObject *self,
              PIXELS      LeftEdge,
              PIXELS      TopEdge ));
   tPoint (*Size)
             __PARMS(( GraphicObject *self ));
   tPoint (*AskSize)
             __PARMS(( GraphicObject *self,
              PIXELS            Width,
              PIXELS            Height ));
   tPoint (*SetSize)
             __PARMS(( GraphicObject *self,
              PIXELS      Width,
              PIXELS      Height ));
   UWORD  (*SizeFlags)
             __PARMS(( GraphicObject *self ));

   void (*Render)
             __PARMS(( GraphicObject *self,
              RastPort  *RPort ));

   BOOL (*SetTitle)
             __PARMS(( GraphicObject *self,
              char       *title ));

   char *(*Title)
             __PARMS(( GraphicObject *self ));

/* additions for font information */
   TextAttr *(*DefaultFont) __PARMS(( GraphicObject *self ));
   BOOL (*SetDefaultFont) __PARMS(( GraphicObject *self, TextAttr *default_font ));

   AlignInfo *(*TextAlignment) __PARMS(( GraphicObject *self ));

   BOOL (*SetTextAlignment)
             __PARMS(( GraphicObject *self,
              UBYTE         Flags,
              BYTE          Xpad,
              BYTE          Ypad ));

   PClass *BuilderMethods; /* pointer to more methods only used by the
                          ** interface builder.
                          */

   struct pcgWindow *(*InteractorWindow)
             __PARMS(( Interactor *self ));

   void (*SetInteractorWindow)
             __PARMS(( Interactor *self,
              struct pcgWindow *window ));

   Gadget *(*FirstGadget)
             __PARMS(( Interactor *self ));

   USHORT  (*nGadgets)
             __PARMS(( Interactor *self ));

   ULONG (*IDCMPFlags)
             __PARMS(( Interactor *self ));

   USHORT (*ClaimEvent)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   USHORT (*Respond)
             __PARMS(( Interactor *self,
              IntuiMessage *event ));

   void (*Refresh)
             __PARMS(( Interactor *self ));

   BOOL (*EnableIactor)
             __PARMS(( Interactor *self,
              BOOL       enable ));

   BOOL (*isEnabled)
             __PARMS(( Interactor *self  ));

   BOOL (*Activate)
             __PARMS(( Interactor *self,
              BOOL       activate ));

   BOOL (*isActive)
             __PARMS(( Interactor *self ));

/*--- New Methods ----------------------------*/

   struct Window *(*OpenWindow)
             __PARMS(( pcgWindow *self ));

   void (*CloseWindow)
             __PARMS(( pcgWindow *self ));

   struct Window *(*iWindow)
             __PARMS(( pcgWindow *self ));

   RastPort *(*RPort)
             __PARMS(( pcgWindow *self ));

   ULONG (*SetIDCMPFlags)
             __PARMS(( pcgWindow *self,
              ULONG       newflags ));

   void (*AddGraphicObject)
             __PARMS(( pcgWindow *self, GraphicObject *graphic ));

   void (*RemoveGraphicObject)
             __PARMS(( pcgWindow *self, GraphicObject *graphic ));

   void (*AddInteractor)
             __PARMS(( pcgWindow *self, Interactor *interactor ));

   void (*RemoveInteractor)
             __PARMS(( pcgWindow *self, Interactor *interactor ));

   void (*AddMenuStrip) __PARMS(( pcgWindow *window, Menu *menustrip ));

   void (*RemoveMenuStrip) __PARMS(( pcgWindow *window ));
};

struct pcgWindowClass *pcgWindowClass __PARMS(( void ));

void pcgWindowClass_Init __PARMS(( struct pcgWindowClass *class ));

#endif